# ChunkCodecCore

A consistent Julia interface for lossless encoding and decoding of bytes in memory.

This package defines the ChunkCodec interface and implements a noop and byte shuffle encoder and decoder.

"""
    abstract type Codec

Required information to decode encoded data.

Properties are public for reading.

Required methods for a type `T <: Codec` to implement:
- `decode_options(::T)::DecodeOptions`
"""
abstract type Codec end

"""
    abstract type EncodeOptions

Options for encoding data.

Properties are public for reading.
All `EncodeOptions` have a keyword argument constructor
that accept all properties as arguments.
All `EncodeOptions` have a `codec::Codec` property.

Required methods for a type `T <: EncodeOptions` to implement:
- `decoded_size_range(::T)::StepRange{Int64, Int64}`
- `encode_bound(::T, src_size::Int64)::Int64`
- `try_encode!(::T, dst::AbstractVector{UInt8}, src::AbstractVector{UInt8}; kwargs...)::MaybeSize`

Optional methods to implement:
- `is_thread_safe(::T)::Bool`: defaults to `false`.
- `is_lossless(::T)::Bool`: defaults to `true`.
"""
abstract type EncodeOptions end


"""
    abstract type DecodeOptions

Options for decoding data.

Properties are public for reading.
All `DecodeOptions` have a keyword argument constructor
that accept all properties as arguments.
All `DecodeOptions` have a `codec::Codec` property.

Required methods for a type `T <: DecodeOptions` to implement:
- `try_find_decoded_size(::T, src::AbstractVector{UInt8})::Union{Nothing, Int64}`
- `try_decode!(::T, dst::AbstractVector{UInt8}, src::AbstractVector{UInt8}; kwargs...)::MaybeSize`

Optional methods to implement:
- `is_thread_safe(::T)::Bool`: defaults to `false`.
- `can_concatenate(::T)::Bool`: defaults to `false`.
- `try_resize_decode!(::T, dst::AbstractVector{UInt8}, src::AbstractVector{UInt8}, max_size::Int64; kwargs...)::MaybeSize`: defaults to using `try_decode!` and `try_find_decoded_size`
"""
abstract type DecodeOptions end

# The Shuffle codec

"""
    struct ShuffleCodec <: Codec
    ShuffleCodec(element_size::Integer)

Byte shuffle. The element size is required
to be able to decode the shuffle.

For example:

```julia
[
0x11, 0x12, 0x13,
0x21, 0x22, 0x23,
0x31, 0x32, 0x33,
0x41, 0x42, 0x43,
]
```

with element size 3 will be encoded as

```julia
[
0x11, 0x21, 0x31, 0x41,
0x12, 0x22, 0x32, 0x42,
0x13, 0x23, 0x33, 0x43,
]
```

If the length of the data is not evenly divisible
by the element size, the remainder data is appended.

For example "12312312312345" with element size 3 will be encoded as
"11112222333345"

A `ShuffleCodec` can be used as an encoder or decoder.
"""
struct ShuffleCodec <: Codec
    element_size::Int64
    function ShuffleCodec(element_size::Integer)
        check_in_range(Int64(1):typemax(Int64); element_size)
        new(Int64(element_size))
    end
end

decode_options(x::ShuffleCodec) = ShuffleDecodeOptions(;codec=x) # default decode options

# Allow ShuffleCodec to be used as an encoder
decoded_size_range(::ShuffleCodec) = Int64(0):Int64(1):typemax(Int64)-Int64(1)

encode_bound(::ShuffleCodec, src_size::Int64)::Int64 = src_size

function try_encode!(e::ShuffleCodec, dst::AbstractVector{UInt8}, src::AbstractVector{UInt8}; kwargs...)::MaybeSize
    dst_size::Int64 = length(dst)
    src_size::Int64 = length(src)
    element_size = e.element_size
    check_in_range(decoded_size_range(e); src_size)
    if dst_size < src_size
        NOT_SIZE
    else
        if src_size>>1 < element_size || element_size == 1
            copyto!(dst, src)
            return src_size
        end
        n_elements, n_remainder = fldmod(src_size, element_size)
        @inbounds for i in 0:(element_size-1)
            for j in 0:(n_elements-1)
                dst[begin + j + n_elements*i] = src[begin + i + element_size*j]
            end
        end
        offset = n_elements*element_size
        for i in 0:(n_remainder-1)
            dst[begin + offset + i] = src[begin + offset + i]
        end
        return src_size
    end
end

"""
    struct ShuffleEncodeOptions <: EncodeOptions
    ShuffleEncodeOptions(; kwargs...)

Byte shuffle encoding.

# Keyword Arguments

- `codec::ShuffleCodec`
"""
struct ShuffleEncodeOptions <: EncodeOptions
    codec::ShuffleCodec
end
function ShuffleEncodeOptions(;
        codec::ShuffleCodec,
        kwargs...
    )
    ShuffleEncodeOptions(codec)
end

is_thread_safe(::ShuffleEncodeOptions) = true

decoded_size_range(x::ShuffleEncodeOptions) = decoded_size_range(x.codec)

encode_bound(x::ShuffleEncodeOptions, src_size::Int64)::Int64 = encode_bound(x.codec, src_size)

function try_encode!(x::ShuffleEncodeOptions, dst::AbstractVector{UInt8}, src::AbstractVector{UInt8}; kwargs...)::MaybeSize
    try_encode!(x.codec, dst, src)
end

"""
    struct ShuffleDecodeOptions <: DecodeOptions
    ShuffleDecodeOptions(; kwargs...)

Byte shuffle decoding.

# Keyword Arguments

- `codec::ShuffleCodec`
"""
struct ShuffleDecodeOptions <: DecodeOptions
    codec::ShuffleCodec
end
function ShuffleDecodeOptions(;
        codec::ShuffleCodec,
        kwargs...
    )
    ShuffleDecodeOptions(codec)
end

is_thread_safe(::ShuffleDecodeOptions) = true

function try_find_decoded_size(::ShuffleDecodeOptions, src::AbstractVector{UInt8})::Int64
    length(src)
end

function try_decode!(d::ShuffleDecodeOptions, dst::AbstractVector{UInt8}, src::AbstractVector{UInt8}; kwargs...)::MaybeSize
    dst_size::Int64 = length(dst)
    src_size::Int64 = length(src)
    element_size = d.codec.element_size
    if dst_size < src_size
        NOT_SIZE
    else
        if src_size>>1 < element_size || element_size == 1
            copyto!(dst, src)
            return MaybeSize(src_size)
        end
        n_elements, n_remainder = fldmod(src_size, element_size)
        @inbounds for i in 0:(element_size-1)
            for j in 0:(n_elements-1)
                dst[begin + i + element_size*j] = src[begin + j + n_elements*i]
            end
        end
        offset = n_elements*element_size
        for i in 0:(n_remainder-1)
            dst[begin + offset + i] = src[begin + offset + i]
        end
        return MaybeSize(src_size)
    end
end

# The Noop codec

"""
    struct NoopCodec <: Codec
    NoopCodec()

Copies the input.

See also [`NoopEncodeOptions`](@ref) and [`NoopDecodeOptions`](@ref)
"""
struct NoopCodec <: Codec end
decode_options(::NoopCodec) = NoopDecodeOptions() # default decode options

"""
    struct NoopEncodeOptions <: EncodeOptions
    NoopEncodeOptions(; kwargs...)

Copies the input.

# Keyword Arguments

- `codec::NoopCodec=NoopCodec()`
"""
struct NoopEncodeOptions <: EncodeOptions
    codec::NoopCodec
end
function NoopEncodeOptions(;
        codec::NoopCodec=NoopCodec(),
        kwargs...
    )
    NoopEncodeOptions(codec)
end

is_thread_safe(::NoopEncodeOptions) = true

decoded_size_range(::NoopEncodeOptions) = Int64(0):Int64(1):typemax(Int64)-Int64(1)

encode_bound(::NoopEncodeOptions, src_size::Int64)::Int64 = src_size

function try_encode!(e::NoopEncodeOptions, dst::AbstractVector{UInt8}, src::AbstractVector{UInt8}; kwargs...)::MaybeSize
    dst_size::Int64 = length(dst)
    src_size::Int64 = length(src)
    check_in_range(decoded_size_range(e); src_size)
    if dst_size < src_size
        NOT_SIZE
    else
        copyto!(dst, src)
        src_size
    end
end

"""
    struct NoopDecodeOptions <: DecodeOptions
    NoopDecodeOptions(; kwargs...)

Copies the input.

# Keyword Arguments

- `codec::NoopCodec=NoopCodec()`
"""
struct NoopDecodeOptions <: DecodeOptions
    codec::NoopCodec
end
function NoopDecodeOptions(;
        codec::NoopCodec=NoopCodec(),
        kwargs...
    )
    NoopDecodeOptions(codec)
end

is_thread_safe(::NoopDecodeOptions) = true

can_concatenate(::NoopDecodeOptions) = true

function try_find_decoded_size(::NoopDecodeOptions, src::AbstractVector{UInt8})::Int64
    length(src)
end

function try_decode!(::NoopDecodeOptions, dst::AbstractVector{UInt8}, src::AbstractVector{UInt8}; kwargs...)::MaybeSize
    dst_size::Int64 = length(dst)
    src_size::Int64 = length(src)
    if dst_size < src_size
        NOT_SIZE
    else
        copyto!(dst, src)
        MaybeSize(src_size)
    end
end

module ChunkCodecCore

export decode, encode

if VERSION >= v"1.11.0-DEV.469"
    eval(Meta.parse("""
        public
            Codec,
            EncodeOptions,
            DecodeOptions,

            MaybeSize,
            is_size,
            NOT_SIZE,
            DecodingError,
            DecodedSizeError,
            decode!,

            decode_options,

            decoded_size_range,
            encode_bound,
            try_encode!,

            try_find_decoded_size,
            try_decode!,

            check_in_range,
            check_contiguous,
            grow_dst!,

            can_concatenate,
            is_thread_safe,
            try_resize_decode!,
            is_lossless,

            NoopCodec,
            NoopEncodeOptions,
            NoopDecodeOptions,

            ShuffleCodec,
            ShuffleEncodeOptions,
            ShuffleDecodeOptions
    """))
end

include("types.jl")
include("errors.jl")
include("interface.jl")
include("noop.jl")
include("shuffle.jl")

end

"""
    encode(e, src::AbstractVector{UInt8})::Vector{UInt8}

Encode the input vector `src` using encoder `e`.
`e` must implement [`decoded_size_range`](@ref),
[`encode_bound`](@ref), and [`try_encode!`](@ref).

Throw an error if `length(src)` is not in `decoded_size_range(e)`.

Otherwise throw an error.

Precondition: `src` has a stride of 1.

See also [`EncodeOptions`](@ref) and [`decode`](@ref).
"""
function encode(e, src::AbstractVector{UInt8})::Vector{UInt8}
    src_size::Int64 = length(src)
    check_in_range(decoded_size_range(e)::StepRange{Int64, Int64}; src_size)
    dst_size_bound = encode_bound(e, src_size)::Int64
    if dst_size_bound == typemax(Int64)
        throw(ArgumentError("`encode_bound(e, $(src_size))` saturated"))
    end
    dst = Vector{UInt8}(undef, dst_size_bound)
    real_dst_size = Int64(try_encode!(e, dst, src)::MaybeSize)
    @assert real_dst_size ∈ 0:dst_size_bound
    if real_dst_size < dst_size_bound
        resize!(dst, real_dst_size)
    end
    dst
end

"""
    decode(d, src::AbstractVector{UInt8}; max_size::Integer=typemax(Int64), size_hint::Integer=Int64(0))::Vector{UInt8}

Decode the input data `src` using decoder `d`.
`d` must implement [`try_find_decoded_size`](@ref), [`try_decode!`](@ref), and optionally [`try_resize_decode!`](@ref).

Throw a [`DecodedSizeError`](@ref) if decoding fails because the output size would be greater than `max_size`.

Throw a [`DecodingError`](@ref) if decoding fails because the input data is not valid.

Otherwise throw an error.

If you have a good idea of what the decoded size is, using the `size_hint` keyword argument
can greatly improve performance.

Precondition: `src` has a stride of 1.

See also [`DecodeOptions`](@ref) and [`encode`](@ref)
"""
function decode(
        d,
        src::AbstractVector{UInt8};
        max_size::Integer=typemax(Int64),
        size_hint::Integer=Int64(0),
    )::Vector{UInt8}
    _clamp_max_size::Int64 = clamp(max_size, Int64)
    if _clamp_max_size < Int64(0)
        throw(DecodedSizeError(_clamp_max_size, NOT_SIZE))
    end
    _clamp_size_hint::Int64 = clamp(size_hint, Int64(0), _clamp_max_size)
    dst = Vector{UInt8}(undef, _clamp_size_hint)
    maybe_dst_size = try_resize_decode!(d, dst, src, _clamp_max_size)::MaybeSize
    if !is_size(maybe_dst_size)
        throw(DecodedSizeError(_clamp_max_size, maybe_dst_size))
    end
    real_dst_size = Int64(maybe_dst_size)
    @assert real_dst_size ∈ 0:_clamp_max_size
    @assert real_dst_size ≤ length(dst)
    resize!(dst, real_dst_size)
    dst
end

"""
    decode!(d, dst::AbstractVector{UInt8}, src::AbstractVector{UInt8}) -> dst

Decode the input data `src` into `dst` using decoder `d`.
`d` must implement [`try_decode!`](@ref).

Throw a [`DecodedSizeError`](@ref) if the decoded output size is not exactly `length(dst)`.

Throw a [`DecodingError`](@ref) if decoding fails because the input data is not valid.

Otherwise throw an error.

Precondition: `dst` and `src` do not overlap in memory.

Precondition: `src` and `dst` have a stride of 1.

See also [`decode`](@ref) and [`encode`](@ref)
"""
function decode!(d, dst::AbstractVector{UInt8}, src::AbstractVector{UInt8})
    expected_size::Int64 = length(dst)
    n = try_decode!(d, dst, src)::MaybeSize
    if n.val != expected_size
        throw(DecodedSizeError(expected_size, n))
    else
        dst
    end
end

"""
    decode_options(::Codec)::DecodeOptions

Return the default decode options for the codec.
"""
function decode_options end

"""
    decoded_size_range(e)::StepRange{Int64, Int64}

Return the range of allowed `src` sizes for encoding.

See also [`encode_bound`](@ref)
"""
function decoded_size_range end

"""
    encode_bound(e, src_size::Int64)::Int64

Return the size of `dst` required to ensure [`try_encode!`](@ref)
succeeds regardless of `src`'s content if `src_size` is also in
[`decoded_size_range(e)`](@ref) and there is enough memory.

On the domain of `0:typemax(Int64)` this function must not error and must be monotonically increasing.
"""
function encode_bound end

"""
    try_encode!(e, dst::AbstractVector{UInt8}, src::AbstractVector{UInt8}; kwargs...)::MaybeSize

Try to encode `src` into `dst` using encoder `e`.

Return the size of the encoded output in `dst` if successful.

If `dst` is too small, return `NOT_SIZE`.

Throw an error if `length(src)` is not in `decoded_size_range(e)`

Otherwise throw an error.

Precondition: `dst` and `src` do not overlap in memory.

Precondition: `src` and `dst` have a stride of 1.

All of `dst` can be written to or used as scratch space by the encoder.
Only the initial returned number of bytes are valid output.

See also [`encode_bound`](@ref) and [`decoded_size_range`](@ref)
"""
function try_encode! end

"""
    is_thread_safe(::Union{Codec, DecodeOptions, EncodeOptions})::Bool

Return `true` if it is safe to use the options to encode or decode concurrently in multiple threads.
"""
is_thread_safe(::EncodeOptions) = false
is_thread_safe(::DecodeOptions) = false
is_thread_safe(c::Codec) = is_thread_safe(decode_options(c))

"""
    is_lossless(e)::Bool

Return `true` if the encoder is lossless.
"""
is_lossless(::Any) = true

"""
    try_find_decoded_size(d, src::AbstractVector{UInt8})::Union{Nothing, Int64}

Try to return the size of the decoded output of `src` using `d`.

If the size cannot be quickly determined, return `nothing`.

If the encoded data is found to be invalid, throw a `DecodingError`.

If an `Int64` is returned, it must be the exact size of the decoded output.
If [`try_decode!`](@ref) is called with a `dst` of this size, it must succeed and return the same size, or throw an error.
"""
function try_find_decoded_size end

"""
    try_decode!(d, dst::AbstractVector{UInt8}, src::AbstractVector{UInt8}; kwargs...)::MaybeSize

Try to decode `src` into `dst` using decoder `d`.

Return the size of the decoded output in `dst` if successful.

If `dst` is too small to fit the decoded output, return `NOT_SIZE`.
If `dst` is too small but a positive hint of the required size can be found, return `MaybeSize(-hint)`.

Throw a [`DecodingError`](@ref) if decoding fails because the input data is not valid.

Otherwise throw an error.

Precondition: `dst` and `src` do not overlap in memory.

Precondition: `src` and `dst` have a stride of 1.

All of `dst` can be written to or used as scratch space by the decoder.
Only the initial returned number of bytes are valid output.
"""
function try_decode! end

"""
    try_resize_decode!(d, dst::AbstractVector{UInt8}, src::AbstractVector{UInt8}, max_size::Int64; kwargs...)::MaybeSize

Try to decode the input `src` into `dst` using decoder `d`.

Return the size of the decoded output in `dst` if successful.

`dst` can be grown using the `resize!` function to any size between one more than the original length of `dst` and `max_size`.

Return `NOT_SIZE` if the size of `dst` is too small to contain the decoded output and cannot be grown due to the `max_size` restriction.
If a positive hint of the size can be found, return `MaybeSize(-hint)`.

Precondition: `dst` and `src` do not overlap in memory.

Precondition: `src` and `dst` have a stride of 1.

All of `dst` can be written to or used as scratch space by the decoder.
Only the initial returned number of bytes are valid output.
"""
function try_resize_decode!(d, dst::AbstractVector{UInt8}, src::AbstractVector{UInt8}, max_size::Int64; kwargs...)::MaybeSize
    init_dst_size::Int64 = length(dst)
    maybe_decoded_size = try_find_decoded_size(d, src)::Union{Nothing, Int64}
    if isnothing(maybe_decoded_size)
        while true
            ds = try_decode!(d, dst, src)::MaybeSize
            if !is_size(ds)
                if length(dst) ≥ max_size
                    return ds
                end
                local hint = -ds.val
                if hint ≤ length(dst)
                    grow_dst!(dst, max_size)
                else
                    resize!(dst, min(hint, max_size))
                end
            else
                @assert Int64(ds) ∈ 0:length(dst)
                return ds
            end
        end
    else
        decoded_size = Int64(maybe_decoded_size)
        @assert !signbit(decoded_size)
        @assert !signbit(init_dst_size)
        if decoded_size > init_dst_size
            if decoded_size > max_size
                return MaybeSize(-decoded_size)
            end
            resize!(dst, decoded_size)
        end
        real_dst_size = try_decode!(d, dst, src)::MaybeSize
        @assert Int64(real_dst_size) == decoded_size
        return real_dst_size
    end
end

"""
    can_concatenate(d)::Bool

Return `true` if the decoder has concatenation transparency.

If `true`, and some encoded data `a` and `b` decode to `x` and `y` respectively, then
the concatenation of `a` and `b` will
decode to the concatenation of `x` and `y`
"""
can_concatenate(::Any) = false

# allow passing codec to decode
try_find_decoded_size(c::Codec, src::AbstractVector{UInt8}) = try_find_decoded_size(decode_options(c), src)
try_decode!(c::Codec, dst::AbstractVector{UInt8}, src::AbstractVector{UInt8}; kwargs...) = try_decode!(decode_options(c), dst, src; kwargs...)
try_resize_decode!(c::Codec, dst::AbstractVector{UInt8}, src::AbstractVector{UInt8}, max_size::Int64; kwargs...) = try_resize_decode!(decode_options(c), dst, src, max_size; kwargs...)
can_concatenate(c::Codec) = can_concatenate(decode_options(c))

"""
    check_contiguous(x::AbstractVector{UInt8})

Check if the given vector is contiguous in memory.
Throw an error if the vector is not contiguous or if its length cannot be represented as Int64.
"""
function check_contiguous(x::AbstractVector{UInt8})
    y = Base.cconvert(Ptr{UInt8}, x)
    GC.@preserve y Base.unsafe_convert(Ptr{UInt8}, y)
    isone(only(strides(x))) || throw(ArgumentError("vector is not contiguous in memory"))
    Int64(length(x))
    @assert !signbit(length(x))
    nothing
end

"""
    check_in_range(range; kwargs...)

Check if all keyword arguments are within the specified range.
Throw an `ArgumentError` if any value is outside the range.

# Arguments
- `range`: The allowed range of values
- `kwargs...`: Keyword arguments to check against the range
"""
function check_in_range(range; kwargs...)
    for (k, v) in kwargs
        if v ∉ range
            throw(ArgumentError("$(k) ∈ $(range) must hold. Got\n$(k) => $(v)"))
        end
    end
end

"""
    grow_dst!(dst::AbstractVector{UInt8}, max_size::Int64)::Union{Nothing, Int64}

Grow the destination vector `dst` to a size between its current size and `max_size`.
Return the new size of `dst` if it was grown, or `nothing` if it could not be grown due to the `max_size` restriction.
"""
function grow_dst!(dst::AbstractVector{UInt8}, max_size::Int64)::Union{Nothing, Int64}
    cur_size::Int64 = length(dst)
    if cur_size ≥ max_size
        return
    end
    # This inequality prevents overflow
    next_size::Int64 = if max_size - cur_size ≤ cur_size
        max_size
    else
        max(2*cur_size, Int64(1))
    end
    resize!(dst, next_size)
    return next_size
end

"""
    abstract type DecodingError <: Exception

Generic error for data that cannot be decoded.
"""
abstract type DecodingError <: Exception end

"""
    struct MaybeSize
        val::Int64
    end

If `val ≥ 0` it is a size, and can be converted back and forth with `Int64`.
If `val < 0` converting to and from `Int64` will error.
If `val == typemin(Int64)` it is an unknown size.
Otherwise it is a size hint of `-val`.

"""
struct MaybeSize
    val::Int64
end

"""
    const NOT_SIZE = MaybeSize(typemin(Int64))
"""
const NOT_SIZE = MaybeSize(typemin(Int64))
function is_size(x::MaybeSize)::Bool
    !signbit(x.val)
end
function Base.Int64(x::MaybeSize)
    if !is_size(x)
        throw(InexactError(:Int64, Int64, x))
    else
        x.val
    end
end
function Base.convert(::Type{Int64}, x::MaybeSize)
    Int64(x)
end
function Base.convert(::Type{MaybeSize}, x::Int64)::MaybeSize
    if signbit(x)
        throw(InexactError(:convert, MaybeSize, x))
    else
        MaybeSize(x)
    end
end

"""
    struct DecodedSizeError <: Exception
    DecodedSizeError(max_size, decoded_size)

Exception thrown when the decoded data size doesn't match expectations or exceeds limits.

# Fields
- `max_size::Int64`: The maximum allowed or expected size in bytes
- `decoded_size::MaybeSize`: The actual decoded size, size hint, or `NOT_SIZE` if unknown

This error can occur in several scenarios:
1. Decoded size exceeds the maximum allowed size
2. Decoded size is less than expected
3. Decoder provides a size hint when the decoded size exceeds limits
4. Decoded size is completely unknown but exceeds limits
"""
struct DecodedSizeError <: Exception
    max_size::Int64
    decoded_size::MaybeSize
end

function Base.showerror(io::IO, err::DecodedSizeError)
    print(io, "DecodedSizeError: ")
    if err.decoded_size === NOT_SIZE
        print(io, "decoded size > ")
        print(io, err.max_size)
    elseif !is_size(err.decoded_size)
        suggested_size = -err.decoded_size.val
        print(io, "decoded size > ")
        print(io, err.max_size)
        print(io, ", try max_size = ")
        print(io, suggested_size)
    else
        decoded_size = err.decoded_size.val
        if decoded_size < err.max_size
            print(io, "decoded size ")
            print(io, decoded_size)
            print(io, " < expected ")
            print(io, err.max_size)
        else
            print(io, "decoded size ")
            print(io, decoded_size)
            print(io, " > ")
            print(io, err.max_size)
        end
    end
    nothing
end

using Random: Random
using ChunkCodecCore:
    ChunkCodecCore,
    NoopCodec, NoopEncodeOptions, NoopDecodeOptions,
    ShuffleCodec, ShuffleEncodeOptions, ShuffleDecodeOptions,
    DecodedSizeError, decode, decode!, MaybeSize, NOT_SIZE, is_size
using ChunkCodecTests:ChunkCodecTests, test_codec, test_encoder_decoder
using Aqua: Aqua
using Test: @test, @testset, @test_throws

Aqua.test_all(ChunkCodecCore; persistent_tasks = false)
Aqua.test_all(ChunkCodecTests; persistent_tasks = false)

Random.seed!(1234)

@testset "noop codec" begin
    test_codec(NoopCodec(), NoopEncodeOptions(), NoopDecodeOptions(); trials=100)
    # codec can be used as decoder
    test_encoder_decoder(NoopEncodeOptions(), NoopCodec(); trials=20)
end
@testset "shuffle codec" begin
    for element_size in [1:10; typemax(Int64); typemax(Int64)-1;]
        c = ShuffleCodec(element_size)
        test_codec(
            c,
            ShuffleEncodeOptions(c),
            ShuffleDecodeOptions(c);
            trials=20,
        )
    end
    c = ShuffleCodec(8)
    # ShuffleCodec can be used as an encoder and decoder
    test_encoder_decoder(c, c; trials=20)
    # negative or zero element size should error
    @test_throws ArgumentError ShuffleCodec(0)
    @test_throws ArgumentError ShuffleCodec(-1)
    @test_throws ArgumentError ShuffleCodec(typemin(Int64))
end
@testset "converting MaybeSize" begin
    @test is_size(MaybeSize(0))
    @test is_size(MaybeSize(typemax(Int64)))
    @test !is_size(MaybeSize(-1))
    @test !is_size(MaybeSize(typemin(Int64)))

    @test Int64(MaybeSize(0)) === Int64(0)
    @test Int64(MaybeSize(typemax(Int64))) === Int64(typemax(Int64))
    @test_throws InexactError Int64(MaybeSize(-1))
    @test_throws InexactError Int64(MaybeSize(typemin(Int64)))

    @test convert(Int64, MaybeSize(0)) === Int64(0)
    @test convert(Int64, MaybeSize(typemax(Int64))) === Int64(typemax(Int64))
    @test_throws InexactError convert(Int64, MaybeSize(-1))
    @test_throws InexactError convert(Int64, MaybeSize(typemin(Int64)))

    @test convert(MaybeSize, Int64(0)) === MaybeSize(0)
    @test convert(MaybeSize, typemax(Int64)) === MaybeSize(typemax(Int64))
    @test_throws InexactError convert(MaybeSize, Int64(-1))
    @test_throws InexactError convert(MaybeSize, typemin(Int64))
end
@testset "errors" begin
    @test sprint(Base.showerror, DecodedSizeError(1, MaybeSize(2))) == "DecodedSizeError: decoded size 2 > 1"
    @test sprint(Base.showerror, DecodedSizeError(2, MaybeSize(1))) == "DecodedSizeError: decoded size 1 < expected 2"
    @test sprint(Base.showerror, DecodedSizeError(1, NOT_SIZE)) == "DecodedSizeError: decoded size > 1"
    @test sprint(Base.showerror, DecodedSizeError(1, MaybeSize(-10))) == "DecodedSizeError: decoded size > 1, try max_size = 10"
end
@testset "check helpers" begin
    @test_throws Exception ChunkCodecCore.check_contiguous(@view(zeros(UInt8, 8)[1:2:end]))
    @test_throws Exception ChunkCodecCore.check_contiguous(0x00:0xFF)
    if VERSION ≥ v"1.11"
        @test isnothing(ChunkCodecCore.check_contiguous(Memory{UInt8}(undef, 3)))
    end
    @test isnothing(ChunkCodecCore.check_contiguous(Vector{UInt8}(undef, 3)))
    @test isnothing(ChunkCodecCore.check_contiguous(@view(zeros(UInt8, 8)[1:1:end])))
    @test_throws ArgumentError ChunkCodecCore.check_in_range(1:6; x=0)
    @test_throws ArgumentError ChunkCodecCore.check_in_range(1:6; x=7)
    @test isnothing(ChunkCodecCore.check_in_range(1:6; x=6))
    @test isnothing(ChunkCodecCore.check_in_range(1:6; x=1))

    x = zeros(UInt8, 0)
    for m in [typemin(Int64), Int64(-1), Int64(0)]
        @test isnothing(ChunkCodecCore.grow_dst!(x, m))
        @test length(x) == 0
    end
    @test ChunkCodecCore.grow_dst!(x, Int64(1)) === Int64(1)
    @test length(x) == 1
    @test ChunkCodecCore.grow_dst!(x, typemax(Int64)) == length(x)
    n1 = length(x)
    @test n1 > 1
    @test isnothing(ChunkCodecCore.grow_dst!(x, Int64(n1)))
    @test length(x) == n1
    @test ChunkCodecCore.grow_dst!(x, Int64(n1 + 1)) == n1 + 1
    @test length(x) == n1 + 1
end

# version of NoopDecodeOptions that returns unknown try_find_decoded_size
struct TestDecodeOptions <: ChunkCodecCore.DecodeOptions
    codec::NoopCodec
end
function TestDecodeOptions(;
        codec::NoopCodec=NoopCodec(),
        kwargs...
    )
    TestDecodeOptions(codec)
end
ChunkCodecCore.try_find_decoded_size(::TestDecodeOptions, src::AbstractVector{UInt8}) = nothing
function ChunkCodecCore.try_decode!(::TestDecodeOptions, dst::AbstractVector{UInt8}, src::AbstractVector{UInt8}; kwargs...)::MaybeSize
    dst_size::Int64 = length(dst)
    src_size::Int64 = length(src)
    if dst_size < src_size
        NOT_SIZE
    else
        copyto!(dst, src)
        MaybeSize(src_size)
    end
end

@testset "decode with unknown decoded size" begin
    test_codec(NoopCodec(), NoopEncodeOptions(), TestDecodeOptions(); trials=100)
end

# version of NoopDecodeOptions that returns random size hints in try_decode!
struct RandHintDecodeOptions <: ChunkCodecCore.DecodeOptions
    codec::NoopCodec
end
function RandHintDecodeOptions(;
        codec::NoopCodec=NoopCodec(),
        kwargs...
    )
    RandHintDecodeOptions(codec)
end
ChunkCodecCore.try_find_decoded_size(::RandHintDecodeOptions, src::AbstractVector{UInt8}) = nothing
function ChunkCodecCore.try_decode!(::RandHintDecodeOptions, dst::AbstractVector{UInt8}, src::AbstractVector{UInt8}; kwargs...)::MaybeSize
    dst_size::Int64 = length(dst)
    src_size::Int64 = length(src)
    if dst_size < src_size
        MaybeSize(-rand(Int64(1):2*src_size))
    else
        copyto!(dst, src)
        MaybeSize(src_size)
    end
end

@testset "decode with random decoded size hint" begin
    test_codec(NoopCodec(), NoopEncodeOptions(), RandHintDecodeOptions(); trials=100)
end

@testset "decode size_hint and resizing" begin
    d = TestDecodeOptions()
    @test decode(d, ones(UInt8, Int64(100)); size_hint=Int64(200)) == ones(UInt8, Int64(100))
    @test decode(d, ones(UInt8, Int64(100)); size_hint=Int64(99)) == ones(UInt8, Int64(100))
    @test decode(d, ones(UInt8, Int64(100)); size_hint=Int64(99), max_size=Int64(100)) == ones(UInt8, Int64(100))
    @test_throws DecodedSizeError decode(d, ones(UInt8, Int64(100)); size_hint=Int64(200), max_size=Int64(99))
    # negative max_size
    @test_throws DecodedSizeError(Int64(-1), NOT_SIZE) decode(d, ones(UInt8, Int64(100)); max_size=Int64(-1))
    @test_throws DecodedSizeError(typemin(Int64), NOT_SIZE) decode(d, ones(UInt8, Int64(100)); max_size=typemin(Int128))
end
@testset "decode!" begin
    d = TestDecodeOptions()
    @test_throws DecodedSizeError(3, MaybeSize(2)) decode!(d, zeros(UInt8, 3), ones(UInt8, 2))
    @test_throws DecodedSizeError(3, NOT_SIZE) decode!(d, zeros(UInt8, 3), ones(UInt8, 4))
    dst = zeros(UInt8, 3)
    @test decode!(d, dst, ones(UInt8, 3)) === dst
    @test dst == ones(UInt8, 3)
end
